/*
 * @Author: kael 
 * @Date: 2020-07-08 12:10:52 
 * @Last Modified by: kael
 * @Last Modified time: 2020-07-16 10:42:33
 */

const mkt = require('./mkt');
const querystring = require('querystring');
const execSync = require('child_process').execSync;

// http://web.ifzq.gtimg.cn/appstock/app/usfqkline/get?_var=kline_dayqfq&param=usTSLA.OQ,day,,,10,qfq&r=0.2834233560574715
// http://web.ifzq.gtimg.cn/appstock/app/hkfqkline/get?_var=kline_dayqfq&param=hk00700,day,,,10,qfq&r=0.283423356057471500
// http://web.ifzq.gtimg.cn/appstock/app/fqkline/get?_var=kline_dayqfq&param=sz399006,day,,,10,qfq&r=0.4519900299757633000
function dayqfq(id, days) {
  try {
    let _var = `kline_dayqfq`;
    let _params = {
      _var,
      rand: Math.random(),
      param: `${id},day,,,${days},qfq`,
    };
    // 请求行情接口
    let url = `http://web.ifzq.gtimg.cn/appstock/app/${mkt(id)}fqkline/get?${querystring.stringify(_params)}`;
    let resp = JSON.parse(
      execSync(`curl -sL '${url}'`)
        .toString()
        .replace(`${_var}=`, '')
    );
    // 提取数据
    let data = (resp || {}).data[id] || [];
    return (data.day || data.qfqday).reverse();
  } catch (error) {
    console.log(`kline_dayqfq error:`, error.message);
    return null;
  }
}

module.exports = {
  dayqfq,
};