/*
 * @Author: kael 
 * @Date: 2020-07-14 14:58:56 
 * @Last Modified by: kael
 * @Last Modified time: 2020-07-16 10:41:55
 */

const rq = require('./rq');
const mkt = require('./mkt');
const querystring = require('querystring');

// http://web.ifzq.gtimg.cn/appstock/app/usfqkline/get?_var=kline_dayqfq&param=usTSLA.OQ,day,,,10,qfq&r=0.2834233560574715
// http://web.ifzq.gtimg.cn/appstock/app/hkfqkline/get?_var=kline_dayqfq&param=hk00700,day,,,10,qfq&r=0.283423356057471500
// http://web.ifzq.gtimg.cn/appstock/app/fqkline/get?_var=kline_dayqfq&param=sz399006,day,,,10,qfq&r=0.4519900299757633000
const dayqfq = async (id, days) => {
  let _var = `kline_dayqfq`;
  let _params = {
    _var,
    rand: Math.random(),
    param: `${id},day,,,${days},qfq`,
  };
  let options = {
    hostname: 'web.ifzq.gtimg.cn',
    path: `/appstock/app/${mkt(id)}fqkline/get?${querystring.stringify(_params)}`,
  };

  const parse = (raw = '') => {
    let resp = JSON.parse(raw.toString().replace(`${_var}=`, ''));
    // 提取数据
    let data = (resp || {}).data[id] || [];
    return (data.day || data.qfqday).reverse();
  };

  return rq.apply(options).then(parse);
};

module.exports = {
  dayqfq,
};