/*
 * @Author: kael 
 * @Date: 2020-07-14 15:04:19 
 * @Last Modified by: kael
 * @Last Modified time: 2020-07-14 15:31:31
 */

const http = require('http');
const iconv = require('iconv-lite');

function apply(options, charset = 'GBK') {

  return new Promise((resolve, reject) => {
    http.request(options, function(resp) {
      let chunks = [];

      resp.on('error', function(error) {
        reject(error);
      });

      resp.on('data', function(chunk) {
        chunks.push(chunk);
      });

      resp.on('end', function() {
        let contentTypeCharset = ((resp.headers['content-type'] || '').match(/charset=(\S+)/) || [])[1] || charset;
        resolve(iconv.decode(Buffer.concat(chunks), contentTypeCharset));
      });

    })
    .end();
  });

}

module.exports = {
  apply,
};